package cn.com.infosec.asn1;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

public class ASN1StreamParser {
   private final InputStream _in;
   private final int _limit;

   public ASN1StreamParser(InputStream in) {
      this(in, Integer.MAX_VALUE);
   }

   public ASN1StreamParser(InputStream in, int limit) {
      this._in = in;
      this._limit = limit;
   }

   public ASN1StreamParser(byte[] encoding) {
      ASN1StreamParser var10000 = this;
      ByteArrayInputStream var2;
      var2 = new ByteArrayInputStream.<init>(encoding);
      var10000.<init>(var2, encoding.length);
   }

   private void set00Check(boolean enabled) {
      InputStream var2;
      if ((var2 = this._in) instanceof IndefiniteLengthInputStream) {
         ((IndefiniteLengthInputStream)var2).setEofOn00(enabled);
      }

   }

   public DEREncodable readObject() {
      int var1;
      if ((var1 = this._in.read()) == -1) {
         return null;
      } else {
         this.set00Check(false);
         int var2 = 0;
         int var3;
         if ((var3 = var1 & 128) != 0 || (var1 & 64) != 0) {
            var2 = ASN1InputStream.readTagNumber(this._in, var1);
         }

         boolean var4;
         if ((var1 & 32) != 0) {
            var4 = true;
         } else {
            var4 = false;
         }

         int var5 = var1 & -33;
         int var6;
         ASN1StreamParser var8;
         if ((var6 = ASN1InputStream.readLength(this._in, this._limit)) < 0) {
            if (var4) {
               int var10000 = var3;
               IndefiniteLengthInputStream var10;
               var10 = new IndefiniteLengthInputStream.<init>(this._in);
               if (var10000 != 0) {
                  return new BERTaggedObjectParser(var1, var2, var10);
               } else {
                  var8 = new ASN1StreamParser.<init>((InputStream)var10);
                  if (var5 != 4) {
                     if (var5 != 16) {
                        if (var5 == 17) {
                           return new BERSetParser(var8);
                        } else {
                           throw new IOException("unknown BER object encountered");
                        }
                     } else {
                        return new BERSequenceParser(var8);
                     }
                  } else {
                     return new BEROctetStringParser(var8);
                  }
               }
            } else {
               throw new IOException("indefinite length primitive encoding encountered");
            }
         } else {
            DefiniteLengthInputStream var7;
            var7 = new DefiniteLengthInputStream.<init>(this._in, var6);
            if ((var1 & 64) != 0) {
               byte[] var9 = var7.toByteArray();
               return new DERApplicationSpecific(var4, var2, var9);
            } else if (var3 != 0) {
               return new BERTaggedObjectParser(var1, var2, var7);
            } else if (var4) {
               if (var5 != 4) {
                  if (var5 != 16) {
                     if (var5 != 17) {
                        return new DERUnknownTag(var1, var7.toByteArray());
                     } else {
                        var8 = new ASN1StreamParser.<init>((InputStream)var7);
                        return new DERSetParser(var8);
                     }
                  } else {
                     var8 = new ASN1StreamParser.<init>((InputStream)var7);
                     return new DERSequenceParser(var8);
                  }
               } else {
                  var8 = new ASN1StreamParser.<init>((InputStream)var7);
                  return new BEROctetStringParser(var8);
               }
            } else {
               return (DEREncodable)(var5 != 4 ? ASN1InputStream.createPrimitiveDERObject(var1, var7.toByteArray()) : new DEROctetStringParser(var7));
            }
         }
      }
   }

   ASN1EncodableVector readVector() {
      ASN1EncodableVector var1;
      var1 = new ASN1EncodableVector.<init>();

      DEREncodable var2;
      while((var2 = this.readObject()) != null) {
         var1.add(var2.getDERObject());
      }

      return var1;
   }
}
